VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "15"
   ClientHeight    =   2235
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   2445
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   18
      Charset         =   204
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   149
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   163
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Ar(15) As Long

Private Sub Form_Load()
  Move Left, Top, Width - Screen.TwipsPerPixelX * (ScaleWidth - 256), Height - Screen.TwipsPerPixelY * (ScaleHeight - 256)
  Randomize Timer
  NewGame
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  MoveBrick (X \ 64) + (Y \ 64) * 4
  ShowField
  If Victory Then
    MsgBox "Victory!", vbOKOnly, "15"
    NewGame
  End If
End Sub

Private Sub ShowField()
  Dim i As Long
  Dim X As Long, Y As Long

  Line (0, 0)-(255, 255), &H507050, BF
  For i = 0 To 15
    X = (i And 3) * 64
    Y = (i \ 4) * 64
    If Ar(i) > 0 Then
      Line (X + 2, Y + 2)-(X + 61, Y + 61), 0, B
      Line (X + 3, Y + 3)-(X + 60, Y + 60), &HA0A0A0, BF
      CurrentX = X + 6 - (Ar(i) < 10) * 7: CurrentY = Y + 22
      ForeColor = &H0: Print Ar(i);
      CurrentX = X + 4 - (Ar(i) < 10) * 7: CurrentY = Y + 20
      ForeColor = &HE0FFA0: Print Ar(i);
    End If
  Next i
End Sub

Private Sub NewGame()
  Dim i As Long

  For i = 0 To 15
    Ar(i) = (i + 1) And 15
  Next i
  For i = 0 To 1023
    MoveBrick Int(Rnd * 16)
  Next i
  ShowField
End Sub

Private Function Victory() As Boolean
  Dim i As Long

  For i = 0 To 15
    If Ar(i) <> ((i + 1) And 15) Then Exit Function
  Next i
  Victory = True
End Function

Private Sub MoveBrick(ByVal i As Long)
  If (i And 3) > 0 Then
    If Ar(i - 1) = 0 Then Swap i, i - 1
  End If
  If (i And 3) < 3 Then
    If Ar(i + 1) = 0 Then Swap i, i + 1
  End If
  If (i And 12) > 0 Then
    If Ar(i - 4) = 0 Then Swap i, i - 4
  End If
  If (i And 12) < 12 Then
    If Ar(i + 4) = 0 Then Swap i, i + 4
  End If
End Sub

Private Sub Swap(ByVal i1 As Long, ByVal i2 As Long)
  Ar(i1) = Ar(i1) Xor Ar(i2)
  Ar(i2) = Ar(i1) Xor Ar(i2)
  Ar(i1) = Ar(i1) Xor Ar(i2)
End Sub
